//============================================================================
//	apci33w.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1999/05/27
//
//============================================================================

unit apci33w;

interface

uses
    Windows;

//-------------------------------------
// װޒ萔
//-------------------------------------
const
    APCI33_SUCCESS	         = 0;  // I
    APCI33_ERR_SYSTEM	         = 1;  // GetLastError sĂ
    APCI33_ERR_NO_DEVICE	 = 2;  // gp\޲Ȃ
    APCI33_ERR_IN_USE	         = 3;  // w肳ꂽ޲͎gp
    APCI33_ERR_INVALID_SLOT      = 4;  // Ș_ۯĔԍw肵
    APCI33_ERR_RESOURCE	         = 5;  // ؿװ
    APCI33_ERR_INVALID_PORT      = 6;  // ȃ|[gv
    APCI33_ERR_INVALID_ARGUMENT  = 7;  // Ȉv
    APCI33_ERR_NO_CREATE	 = 8;  // ޲شĂĂ܂
    APCI33_ERR_WRAPDLL 	         = DWord(-1);  // ׯ߰֐װ
//-------------------------------------
// ߰Ĕԍ萔
//-------------------------------------
    APCI33_PORT_1 = 0;
    APCI33_PORT_2 = 1;
    APCI33_PORT_3 = 2;
    APCI33_PORT_4 = 3;
    APCI33_PORT_5 = 4;
    APCI33_PORT_6 = 5;
    APCI33_PORT_7 = 6;
    APCI33_PORT_8 = 7;
//-------------------------------------
// ̑萔
//-------------------------------------
    APCI33_DLL_NAME  = 'apci33.dll'; // DLĻٖ
    APCI33_MAX_PORTS = 8;	     // ߰Đ
    APCI33_MAX_SLOTS = 16;	     // őۯĐ
    APCI33_DEVICE_ID = $136c9133;    // ޲ID
    APCI33_SLOT_AUTO = $ffff;	     // AutoSlotl
//-------------------------------------
// ؿ\
//-------------------------------------
    APCI33_MAX_MEM = 9;
    APCI33_MAX_IO  = 20;
    APCI33_MAX_DMA = 7;

type
    TAPCI33RESOURCE = record
    dwNumMemWindows:                                DWORD;    // س޳(gp)
    dwMemBase:	     array [1 .. APCI33_MAX_MEM] of DWORD;    // س޳ްڽ(gp)
    dwMemLength:     array [1 .. APCI33_MAX_MEM] of DWORD;    // س޳(gp)
    dwMemAttrib:     array [1 .. APCI33_MAX_MEM] of DWORD;    // س޳(gp)
    dwNumIOPorts:       			    DWORD;    // I/O߰Đ
    dwIOPortBase:    array [1 .. APCI33_MAX_IO] of  DWORD;    // I/O߰ްڽ
    dwIOPortLength:  array [1 .. APCI33_MAX_IO] of  DWORD;    // I/O߰Ē
    dwNumDMAs:	      	      	                    DWORD;    // DMAِ(gp)
    dwDMALst:	     array [1 .. APCI33_MAX_DMA] of DWORD;    // DMAؽ(gp)
    dwDMAAttrib:     array [1 .. APCI33_MAX_DMA] of DWORD;    // DMAّؽ(gp)
    dwReserved1:     array [1 .. 3] of		    DWORD;    // \(gp)
end;
//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Apci33wDllOpen: Boolean;
// DLL ۰
function Apci33wDllClose: Boolean;
// aPCI-P33 DLL,޲ײްްޮݔԍ擾
function Apci33wGetVersion(var pdwDllVersion:DWord; var pdwDriverVersion:DWord): Boolean;
// CӂaPCI-P33̎gp錾
function Apci33wCreate(var pwLogSlot:Word): Boolean;
// CӂaPCI-P33̎gpJ
function Apci33wClose(wLogSlot:Word): Boolean;
// ؿ擾
function Apci33wGetResource(wLogSlot:Word; var pResInfo:TAPCI33RESOURCE): Boolean;
// Cӂ߰Ăްo
function Apci33wOutPort(wLogSlot:Word; dwLogPort:DWord; bOutValue:Byte): Boolean;
// aPCI-P33̴װ
function Apci33wGetLastError(wLogSlot:Word): DWord;
// ۰ذ̒l擾
function Apci33wGetSwitchValue(wLogSlot:Word; var pdwSwitchValue:DWord): Boolean;

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
    hDLL: THandle = 0;

type
    TApci33GetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): BOOL; stdcall;
    TApci33Create = function(var pwLogSlot:Word): BOOL; stdcall;
    TApci33Close = function(wLogSlot:WORD): BOOL; stdcall;
    TApci33GetResource = function(wLogSlot:WORD; var pres:TAPCI33RESOURCE): BOOL; stdcall;
    TApci33OutPort = function(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): BOOL; stdcall;
    TApci33GetLastError = function(wLogSlot:WORD): DWORD; stdcall;
    TApci33GetSwitchValue = function(wLogSlot:WORD; var pdwSwitchValue:DWORD): BOOL; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
    pApci33GetVersion: TApci33GetVersion;
    pApci33Create: TApci33Create;
    pApci33Close: TApci33Close;
    pApci33GetResource: TApci33GetResource;
    pApci33OutPort: TApci33OutPort;
    pApci33GetLastError: TApci33GetLastError;
    pApci33GetSwitchValue: TApci33GetSwitchValue;

function Apci33wGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		apci33.dll۰(۰ގʹװƂ)
// 		
// ߂l        True
//		s False
//============================================================================
function Apci33wDllOpen: Boolean;
begin
    Result:=False;
    if hDLL=0 then begin
       hDLL:=LoadLibrary(APCI33_DLL_NAME);
       if hDLL<>0 then begin
          if Apci33wGetDllExportFunc=True then Result:=True
          else Apci33wDllClose;	// DLL֐擾ɎŝDLLN[Y
          end;
    end;
end;
//============================================================================
// 		apci33.dll۰(۰ގʹװƂ)
// 		
// ߂l        True
//		s False
//============================================================================
function Apci33wDllClose: Boolean;
begin
    Result:=False;
    if hDLL<>0 then begin
       if True=FreeLibrary(hDLL) then begin
          hDLL:=0;
          Result:=True;
       end;
    end;
end;
//============================================================================
// 		aPCI-P33 DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion	 DLLްޮݔԍi[̈ւ߲
//		pdwDriverVersion ޲ײްްޮݔԍi[̈ւ߲
// ߂l        True
//		s False
//============================================================================
function Apci33wGetVersion(var pdwDllVersion:DWord; var pdwDriverVersion:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
	    Result:=pApci33GetVersion(pdwDllVersion, pdwDriverVersion)
end;
//============================================================================
// 		aPCI-P33̔Cӂ޲̎gp錾
// 		pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l        True
//		s False
//============================================================================
function Apci33wCreate(var pwLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
	    Result:=pApci33Create(pwLogSlot)
end;
//============================================================================
// 		aPCI-P33̔Cӂ޲̎gpJ
// 		wLogSlot         ޲̘_ۯĔԍ
// ߂l        True
//		s False
//============================================================================
function Apci33wClose(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
    	   Result:=pApci33Close(wLogSlot)
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSlot	ؿ擾޲̘_ۯĔԍ
//		pResInfo	ؿi[\߲̂
// ߂l        True
//		s False
//============================================================================
function Apci33wGetResource(wLogSlot:Word; var pResInfo:TAPCI33RESOURCE): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
	    Result:=pApci33GetResource(wLogSlot, pResInfo)
end;
//============================================================================
// 		Cӂ߰Ăްo
// 		wLogSlot	o͂޲̘_ۯĔԍ
//		dwLogPort	o͂_߰
//		bOutValue       o͂ް
// ߂l        True
//		s False
//============================================================================
function Apci33wOutPort(wLogSlot:Word; dwLogPort:DWord; bOutValue:Byte): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
    	   Result:=pApci33OutPort(wLogSlot, dwLogPort, bOutValue)
end;
//============================================================================
// 		aPCI-P33̴װ
// 		wLogSlot	װ޲̘_ۯĔԍ
// ߂l       װ
//============================================================================
function Apci33wGetLastError(wLogSlot:Word): DWord;
begin
    if hDLL=0 then Result:=APCI33_ERR_WRAPDLL
    else Result:=pApci33GetLastError(wLogSlot)
end;
//============================================================================
// 		۰ذ̒l擾
// 		wLogSlot 	۰ذ̒l擾޲̘_ۯĔԍ
// 		pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l        True
//		s False
//============================================================================
function Apci33wGetSwitchValue(wLogSlot:Word; var pdwSwitchValue:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
	    Result:=pApci33GetSwitchValue(wLogSlot, pdwSwitchValue)
end;
//---------------------------------------------------------------------------
// 	        DLL߰Ċ֐ڽ̎擾
// 	        
// ߂l        True
//		s False
//---------------------------------------------------------------------------
function Apci33wGetDllExportFunc: Boolean;
begin
    Result:=False;
    // Apci33GetVersion ̱ڽ擾
    pApci33GetVersion:=GetProcAddress(hDLL, 'Apci33GetVersion');
    if @pApci33GetVersion=nil then Exit;
    // Apci33Create ̱ڽ擾
    pApci33Create:=GetProcAddress(hDLL, 'Apci33Create');
    if @pApci33Create=nil then Exit;
    // Apci33Close ̱ڽ擾
    pApci33Close:=GetProcAddress(hDLL, 'Apci33Close');
    if @pApci33Close=nil then Exit;
    // Apci33GetResource ̱ڽ擾
    pApci33GetResource:=GetProcAddress(hDLL, 'Apci33GetResource');
    if @pApci33GetResource=nil then Exit;
    // Apci33OutPort ̱ڽ擾
    pApci33OutPort:=GetProcAddress(hDLL, 'Apci33OutPort');
    if @pApci33OutPort=nil then Exit;
    // Apci33GetLastError ̱ڽ擾
    pApci33GetLastError:=GetProcAddress(hDLL, 'Apci33GetLastError');
    if @pApci33GetLastError=nil then Exit;
    // Apci33GetSwitchValue ̱ڽ擾
    pApci33GetSwitchValue:=GetProcAddress(hDLL, 'Apci33GetSwitchValue');
    if @pApci33GetSwitchValue=nil then Exit;
    // SĂ DLL ߰Ċ֐ڽ擾nj
    Result:=True;
end;

end.


