/*****************************************************************************/
/*	apci33w.h																 */
/*																			 */
/*	aPCI-P33															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1999/06/03															 */
/*																			 */
/*****************************************************************************/

#ifndef __APCI33W_H__
#define __APCI33W_H__

#include "apci33.h"

#ifdef __cplusplus
extern "C"{
#endif

#define APCI33_DLL_NAME	  _T("apci33.dll")	// DLL
#define APCI33_ERR_WRAPDLL ((DWORD)-1)		// ׯ߰֐װ

BOOL Apci33wDllOpen();						// DLL ۰
BOOL Apci33wDllClose();						// DLL ۰
BOOL Apci33wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion);	// aPCI-P33 DLL,ײންޮݔԍ擾
BOOL Apci33wCreate(PWORD pwLogSlot);		// CӂaPCI-P33̎gp錾
BOOL Apci33wClose(WORD wLogSlot);			// CӂaPCI-P33̎gpJ
BOOL Apci33wGetResource(WORD wLogSlot, PAPCI33R pResInfo);				// ؿ擾
BOOL Apci33wOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue);	// Cӂ߰Ăްo
DWORD Apci33wGetLastError(WORD wLogSlot);								// aPCI-P33̴װ
BOOL Apci33wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue);		// ۰ذ̒l擾

#ifdef __cplusplus
}
#endif

#endif // __APCI33W_H__
