/*==============================================================================
//	aPCI-P33̒`
//	
//	Copyright ADTEK System Science Co.,Ltd.
//	
//	{ްނAPIC21ްނł
//	
//==============================================================================*/

#if !defined(_APCI33_H)
#define		_APCI33_H


#ifndef _APCICTRL_H
#include	"apcictrl.h"
#endif


/*	Card's Relative Port Address		*/
#define		APCI33_PORT_1		0
#define		APCI33_PORT_2		1
#define		APCI33_PORT_3		2
#define		APCI33_PORT_4		3
#define		APCI33_PORT_5		4
#define		APCI33_PORT_6		5
#define		APCI33_PORT_7		6
#define		APCI33_PORT_8		7

/*	Miscellaneous						*/
#define		APCI33_MAX_SLOTS	16		/*	Maximum Number of Slots 			*/
#define		APCI33_MAX_PORTS	8		/*	Maximum Number of User Ports		*/

/*	Device ID							*/
#define		APCI33_BOARD_ID		0x9133	/*	PCI Bus Device ID					*/
#define		APCI33_VENDOR_ID	0x136c	/*	PCI Bus Vendor ID					*/
										/*	Our Device ID						*/
#define		APCI33_DEVICE_ID	( ( DWORD )APCI33_BOARD_ID\
								| ( ( DWORD )APCI33_VENDOR_ID << 16 ) )


#endif



